/*
 	File:		InputSprocketDefer.h
 
 	Contains:	Interfaces for InputSprocket drivers to insure that their ADB
				service routines are called at virtual memeory (VM) paging safe
				times.
				Requires the software link with InputSprocketDeferLib
 
 	Version:	Technology:	InputSprocket 1.3
 				Release:	InputSprocket 1.3
 
 	Copyright:	 1986-1998, 1995-1997 by Apple Computer, Inc., all rights reserved
 
 	Bugs?:		Please include the the file and version information (from above) with
 				the problem description.  Developers belonging to one of the Apple
 				developer programs can submit bug reports to:
 
 					devsupport@apple.com
 
*/

#pragma once

#ifndef __INPUTSPROCKETDEFER__
#define __INPUTSPROCKETDEFER__

#include <ConditionalMacros.h>
#include <DeskBus.h>

typedef UInt32			ISpADBDeferRef;

typedef CALLBACK_API_C( void , ISpADBDeferCallbackProcPtr )(UInt8 adbCommand, void * adbBuffer, UInt32 refcon);

#ifdef __cplusplus
extern "C" {
#endif
OSErr ISpAllocateADBDeferBlock(ISpADBDeferRef *createBlock);
OSErr ISpDisposeADBDeferBlock(ISpADBDeferRef disposeBlock);
OSErr ISpInstallADBDefer(ISpADBDeferRef refBlock, ADBAddress reqAddress,
                         ISpADBDeferCallbackProcPtr installProc, UInt32 clientRefCon,
						 ADBServiceRoutineUPP *prevRoutine, Ptr *prevDataArea);
OSErr ISpRemoveADBDefer(ISpADBDeferRef refBlock);
#ifdef __cplusplus
}
#endif

#endif
