/*************************************************************************************

File:      ISpEventPane.h

Copyright  1996, 1997, 1998 Apple Computer, Inc., All Rights Reserved


You may incorporate this sample code into your applications without
restriction, though the sample code has been provided "AS IS" and the
responsibility for its operation is 100% yours.  However, what you are
not permitted to do is to redistribute the source as "DSC Sample Code"
after having made changes. If you're going to re-distribute the source,
we require that you make it clear in the source that the code was
descended from Apple Sample Code, but that you've made changes.

*************************************************************************************/


#pragma once

#include <LPane.h>
#include <LPeriodical.h>
#include <LOffscreenView.h>
#include <InputSprocket.h>

class ISpEventPane : public LOffscreenView, LPeriodical
{
public:
	enum {class_ID = 'ISep'};
	
	ISpEventPane(LStream *inStream);
	~ISpEventPane();
	
	static ISpEventPane *CreateISpEventPaneStream(LStream *inStream);
	void SpendTime(const EventRecord &inMacEvent);
	void DrawSelf();
	
	
private:

	Boolean mDataValid;
	
	typedef struct
	{
		OSStatus theError;
		AbsoluteTime when;
		UInt32 data;
		float percent;
		ISpElementReference theElement;
		UInt32 refCon;
		OSType label;
		OSType kind;
		Str63 theString;
	} PrintRecord;
	
	PrintRecord mPrintRecord;
};
